﻿using System;

namespace ObjectOrientedAnimals
{
    class MainClass
    {
        public static void Main(string[] args)
        {
            Cat c1 = new Cat();
            Console.WriteLine(c1.HowDoesItMove());

            Dog d1 = new Dog();
            Console.WriteLine(d1.HowDoesItMove());

            //Instantiate your own animal classes


            Console.ReadLine();
        }
    }

    //This class is being declared as abstract - that means we will not be able
    //to create 'animal' objects
    //We will be able to use it however as a base template to create lots of
    //different varieties of animal...
    public abstract class Animal
    {
        //These are the two attributes that all animals have
        public int NumberOfLegs;
        public int HeightInCms;

        //This is a CONSTRUCTOR
        //It is the piece of code that runs every time we create a new animal object
        //It might contain code to fetch data, run a setup or anything you need
        //This example just contains code to save the parameters 'number of legs' and 'height in cms'
        //to the local variables.
        public Animal(int numberOfLegs, int heightInCms)
        {
            this.NumberOfLegs = numberOfLegs;
            this.HeightInCms = heightInCms;
        }

        //We are creating an abstract move method.
        //This means all things that inherit from Animal will have a HowDoesItMove method
        public abstract string HowDoesItMove();
        
    }

    //We now define a Cat and say it INHERITS from Animal
    //Note the values 4 and 30 being set in the base constructor below
    public class Cat : Animal
    {
        public Cat() : base(numberOfLegs:4, heightInCms:30) {

        }
        public override string HowDoesItMove()
        {
            return "A cat uses its " + NumberOfLegs + " legs to trot about, and is on average " + HeightInCms + " cms tall";
        }
    }

    public class Dog : Animal
    {
        public Dog() : base(numberOfLegs: 4, heightInCms: 60)
        {

        }
        public override string HowDoesItMove()
        {
            return "A dog uses its " + NumberOfLegs + " legs to bound about, and is on average " + HeightInCms + " cms tall";
        }
    }

    //define your own inherited animals here
}
